<?php

/**
 * Base class that represents a row from the 'katao_invoice' table.
 *
 * 
 *
 * @package    lib.model.om
 */
abstract class BaseKataoInvoice extends BaseObject  implements Persistent {


	/**
	 * The Peer class.
	 * Instance provides a convenient way of calling static methods on a class
	 * that calling code may not be able to identify.
	 * @var        KataoInvoicePeer
	 */
	protected static $peer;


	/**
	 * The value for the id field.
	 * @var        int
	 */
	protected $id;


	/**
	 * The value for the katao_member_id field.
	 * @var        int
	 */
	protected $katao_member_id;


	/**
	 * The value for the katao_period_id field.
	 * @var        int
	 */
	protected $katao_period_id;


	/**
	 * The value for the katao_node_id field.
	 * @var        int
	 */
	protected $katao_node_id;


	/**
	 * The value for the katao_cart_id field.
	 * @var        int
	 */
	protected $katao_cart_id;


	/**
	 * The value for the status field.
	 * @var        int
	 */
	protected $status = 1;


	/**
	 * The value for the member_first_name field.
	 * @var        string
	 */
	protected $member_first_name;


	/**
	 * The value for the member_last_name field.
	 * @var        string
	 */
	protected $member_last_name;


	/**
	 * The value for the member_email field.
	 * @var        string
	 */
	protected $member_email;


	/**
	 * The value for the member_address1 field.
	 * @var        string
	 */
	protected $member_address1;


	/**
	 * The value for the member_address2 field.
	 * @var        string
	 */
	protected $member_address2;


	/**
	 * The value for the member_zip field.
	 * @var        string
	 */
	protected $member_zip;


	/**
	 * The value for the member_city field.
	 * @var        string
	 */
	protected $member_city;


	/**
	 * The value for the katao_name field.
	 * @var        string
	 */
	protected $katao_name;


	/**
	 * The value for the katao_address field.
	 * @var        string
	 */
	protected $katao_address;


	/**
	 * The value for the katao_siret_number field.
	 * @var        string
	 */
	protected $katao_siret_number;


	/**
	 * The value for the katao_rcs_number field.
	 * @var        string
	 */
	protected $katao_rcs_number;


	/**
	 * The value for the katao_capital field.
	 * @var        int
	 */
	protected $katao_capital;


	/**
	 * The value for the sol_amount field.
	 * @var        int
	 */
	protected $sol_amount = 0;


	/**
	 * The value for the created_at field.
	 * @var        int
	 */
	protected $created_at;


	/**
	 * The value for the updated_at field.
	 * @var        int
	 */
	protected $updated_at;

	/**
	 * @var        KataoMember
	 */
	protected $aKataoMember;

	/**
	 * @var        KataoPeriod
	 */
	protected $aKataoPeriod;

	/**
	 * @var        KataoNode
	 */
	protected $aKataoNode;

	/**
	 * @var        KataoCart
	 */
	protected $aKataoCart;

	/**
	 * Collection to store aggregation of collKataoInvoiceProducts.
	 * @var        array
	 */
	protected $collKataoInvoiceProducts;

	/**
	 * The criteria used to select the current contents of collKataoInvoiceProducts.
	 * @var        Criteria
	 */
	protected $lastKataoInvoiceProductCriteria = null;

	/**
	 * Flag to prevent endless save loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInSave = false;

	/**
	 * Flag to prevent endless validation loop, if this object is referenced
	 * by another object which falls in this transaction.
	 * @var        boolean
	 */
	protected $alreadyInValidation = false;

	/**
	 * Get the [id] column value.
	 * 
	 * @return     int
	 */
	public function getId()
	{

		return $this->id;
	}

	/**
	 * Get the [katao_member_id] column value.
	 * 
	 * @return     int
	 */
	public function getKataoMemberId()
	{

		return $this->katao_member_id;
	}

	/**
	 * Get the [katao_period_id] column value.
	 * 
	 * @return     int
	 */
	public function getKataoPeriodId()
	{

		return $this->katao_period_id;
	}

	/**
	 * Get the [katao_node_id] column value.
	 * 
	 * @return     int
	 */
	public function getKataoNodeId()
	{

		return $this->katao_node_id;
	}

	/**
	 * Get the [katao_cart_id] column value.
	 * 
	 * @return     int
	 */
	public function getKataoCartId()
	{

		return $this->katao_cart_id;
	}

	/**
	 * Get the [status] column value.
	 * 
	 * @return     int
	 */
	public function getStatus()
	{

		return $this->status;
	}

	/**
	 * Get the [member_first_name] column value.
	 * 
	 * @return     string
	 */
	public function getMemberFirstName()
	{

		return $this->member_first_name;
	}

	/**
	 * Get the [member_last_name] column value.
	 * 
	 * @return     string
	 */
	public function getMemberLastName()
	{

		return $this->member_last_name;
	}

	/**
	 * Get the [member_email] column value.
	 * 
	 * @return     string
	 */
	public function getMemberEmail()
	{

		return $this->member_email;
	}

	/**
	 * Get the [member_address1] column value.
	 * 
	 * @return     string
	 */
	public function getMemberAddress1()
	{

		return $this->member_address1;
	}

	/**
	 * Get the [member_address2] column value.
	 * 
	 * @return     string
	 */
	public function getMemberAddress2()
	{

		return $this->member_address2;
	}

	/**
	 * Get the [member_zip] column value.
	 * 
	 * @return     string
	 */
	public function getMemberZip()
	{

		return $this->member_zip;
	}

	/**
	 * Get the [member_city] column value.
	 * 
	 * @return     string
	 */
	public function getMemberCity()
	{

		return $this->member_city;
	}

	/**
	 * Get the [katao_name] column value.
	 * 
	 * @return     string
	 */
	public function getKataoName()
	{

		return $this->katao_name;
	}

	/**
	 * Get the [katao_address] column value.
	 * 
	 * @return     string
	 */
	public function getKataoAddress()
	{

		return $this->katao_address;
	}

	/**
	 * Get the [katao_siret_number] column value.
	 * 
	 * @return     string
	 */
	public function getKataoSiretNumber()
	{

		return $this->katao_siret_number;
	}

	/**
	 * Get the [katao_rcs_number] column value.
	 * 
	 * @return     string
	 */
	public function getKataoRcsNumber()
	{

		return $this->katao_rcs_number;
	}

	/**
	 * Get the [katao_capital] column value.
	 * 
	 * @return     int
	 */
	public function getKataoCapital()
	{

		return $this->katao_capital;
	}

	/**
	 * Get the [sol_amount] column value.
	 * 
	 * @return     int
	 */
	public function getSolAmount()
	{

		return $this->sol_amount;
	}

	/**
	 * Get the [optionally formatted] [created_at] column value.
	 * 
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return     mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws     PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getCreatedAt($format = 'Y-m-d H:i:s')
	{

		if ($this->created_at === null || $this->created_at === '') {
			return null;
		} elseif (!is_int($this->created_at)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->created_at);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [created_at] as date/time value: " . var_export($this->created_at, true));
			}
		} else {
			$ts = $this->created_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Get the [optionally formatted] [updated_at] column value.
	 * 
	 * @param      string $format The date/time format string (either date()-style or strftime()-style).
	 *							If format is NULL, then the integer unix timestamp will be returned.
	 * @return     mixed Formatted date/time value as string or integer unix timestamp (if format is NULL).
	 * @throws     PropelException - if unable to convert the date/time to timestamp.
	 */
	public function getUpdatedAt($format = 'Y-m-d H:i:s')
	{

		if ($this->updated_at === null || $this->updated_at === '') {
			return null;
		} elseif (!is_int($this->updated_at)) {
			// a non-timestamp value was set externally, so we convert it
			$ts = strtotime($this->updated_at);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse value of [updated_at] as date/time value: " . var_export($this->updated_at, true));
			}
		} else {
			$ts = $this->updated_at;
		}
		if ($format === null) {
			return $ts;
		} elseif (strpos($format, '%') !== false) {
			return strftime($format, $ts);
		} else {
			return date($format, $ts);
		}
	}

	/**
	 * Set the value of [id] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setId($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->id !== $v) {
			$this->id = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::ID;
		}

	} // setId()

	/**
	 * Set the value of [katao_member_id] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setKataoMemberId($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->katao_member_id !== $v) {
			$this->katao_member_id = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::KATAO_MEMBER_ID;
		}

		if ($this->aKataoMember !== null && $this->aKataoMember->getId() !== $v) {
			$this->aKataoMember = null;
		}

	} // setKataoMemberId()

	/**
	 * Set the value of [katao_period_id] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setKataoPeriodId($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->katao_period_id !== $v) {
			$this->katao_period_id = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::KATAO_PERIOD_ID;
		}

		if ($this->aKataoPeriod !== null && $this->aKataoPeriod->getId() !== $v) {
			$this->aKataoPeriod = null;
		}

	} // setKataoPeriodId()

	/**
	 * Set the value of [katao_node_id] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setKataoNodeId($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->katao_node_id !== $v) {
			$this->katao_node_id = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::KATAO_NODE_ID;
		}

		if ($this->aKataoNode !== null && $this->aKataoNode->getId() !== $v) {
			$this->aKataoNode = null;
		}

	} // setKataoNodeId()

	/**
	 * Set the value of [katao_cart_id] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setKataoCartId($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->katao_cart_id !== $v) {
			$this->katao_cart_id = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::KATAO_CART_ID;
		}

		if ($this->aKataoCart !== null && $this->aKataoCart->getId() !== $v) {
			$this->aKataoCart = null;
		}

	} // setKataoCartId()

	/**
	 * Set the value of [status] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setStatus($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->status !== $v || $v === 1) {
			$this->status = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::STATUS;
		}

	} // setStatus()

	/**
	 * Set the value of [member_first_name] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setMemberFirstName($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->member_first_name !== $v) {
			$this->member_first_name = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::MEMBER_FIRST_NAME;
		}

	} // setMemberFirstName()

	/**
	 * Set the value of [member_last_name] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setMemberLastName($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->member_last_name !== $v) {
			$this->member_last_name = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::MEMBER_LAST_NAME;
		}

	} // setMemberLastName()

	/**
	 * Set the value of [member_email] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setMemberEmail($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->member_email !== $v) {
			$this->member_email = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::MEMBER_EMAIL;
		}

	} // setMemberEmail()

	/**
	 * Set the value of [member_address1] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setMemberAddress1($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->member_address1 !== $v) {
			$this->member_address1 = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::MEMBER_ADDRESS1;
		}

	} // setMemberAddress1()

	/**
	 * Set the value of [member_address2] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setMemberAddress2($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->member_address2 !== $v) {
			$this->member_address2 = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::MEMBER_ADDRESS2;
		}

	} // setMemberAddress2()

	/**
	 * Set the value of [member_zip] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setMemberZip($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->member_zip !== $v) {
			$this->member_zip = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::MEMBER_ZIP;
		}

	} // setMemberZip()

	/**
	 * Set the value of [member_city] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setMemberCity($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->member_city !== $v) {
			$this->member_city = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::MEMBER_CITY;
		}

	} // setMemberCity()

	/**
	 * Set the value of [katao_name] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setKataoName($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->katao_name !== $v) {
			$this->katao_name = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::KATAO_NAME;
		}

	} // setKataoName()

	/**
	 * Set the value of [katao_address] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setKataoAddress($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->katao_address !== $v) {
			$this->katao_address = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::KATAO_ADDRESS;
		}

	} // setKataoAddress()

	/**
	 * Set the value of [katao_siret_number] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setKataoSiretNumber($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->katao_siret_number !== $v) {
			$this->katao_siret_number = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::KATAO_SIRET_NUMBER;
		}

	} // setKataoSiretNumber()

	/**
	 * Set the value of [katao_rcs_number] column.
	 * 
	 * @param      string $v new value
	 * @return     void
	 */
	public function setKataoRcsNumber($v)
	{

		// Since the native PHP type for this column is string,
		// we will cast the input to a string (if it is not).
		if ($v !== null && !is_string($v)) {
			$v = (string) $v; 
		}

		if ($this->katao_rcs_number !== $v) {
			$this->katao_rcs_number = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::KATAO_RCS_NUMBER;
		}

	} // setKataoRcsNumber()

	/**
	 * Set the value of [katao_capital] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setKataoCapital($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->katao_capital !== $v) {
			$this->katao_capital = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::KATAO_CAPITAL;
		}

	} // setKataoCapital()

	/**
	 * Set the value of [sol_amount] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setSolAmount($v)
	{

		// Since the native PHP type for this column is integer,
		// we will cast the input value to an int (if it is not).
		if ($v !== null && !is_int($v) && is_numeric($v)) {
			$v = (int) $v;
		}

		if ($this->sol_amount !== $v || $v === 0) {
			$this->sol_amount = $v;
			$this->modifiedColumns[] = KataoInvoicePeer::SOL_AMOUNT;
		}

	} // setSolAmount()

	/**
	 * Set the value of [created_at] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setCreatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [created_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->created_at !== $ts) {
			$this->created_at = $ts;
			$this->modifiedColumns[] = KataoInvoicePeer::CREATED_AT;
		}

	} // setCreatedAt()

	/**
	 * Set the value of [updated_at] column.
	 * 
	 * @param      int $v new value
	 * @return     void
	 */
	public function setUpdatedAt($v)
	{

		if ($v !== null && !is_int($v)) {
			$ts = strtotime($v);
			if ($ts === -1 || $ts === false) { // in PHP 5.1 return value changes to FALSE
				throw new PropelException("Unable to parse date/time value for [updated_at] from input: " . var_export($v, true));
			}
		} else {
			$ts = $v;
		}
		if ($this->updated_at !== $ts) {
			$this->updated_at = $ts;
			$this->modifiedColumns[] = KataoInvoicePeer::UPDATED_AT;
		}

	} // setUpdatedAt()

	/**
	 * Hydrates (populates) the object variables with values from the database resultset.
	 *
	 * An offset (1-based "start column") is specified so that objects can be hydrated
	 * with a subset of the columns in the resultset rows.  This is needed, for example,
	 * for results of JOIN queries where the resultset row includes columns from two or
	 * more tables.
	 *
	 * @param      ResultSet $rs The ResultSet class with cursor advanced to desired record pos.
	 * @param      int $startcol 1-based offset column which indicates which restultset column to start with.
	 * @return     int next starting column
	 * @throws     PropelException  - Any caught Exception will be rewrapped as a PropelException.
	 */
	public function hydrate(ResultSet $rs, $startcol = 1)
	{
		try {

			$this->id = $rs->getInt($startcol + 0);

			$this->katao_member_id = $rs->getInt($startcol + 1);

			$this->katao_period_id = $rs->getInt($startcol + 2);

			$this->katao_node_id = $rs->getInt($startcol + 3);

			$this->katao_cart_id = $rs->getInt($startcol + 4);

			$this->status = $rs->getInt($startcol + 5);

			$this->member_first_name = $rs->getString($startcol + 6);

			$this->member_last_name = $rs->getString($startcol + 7);

			$this->member_email = $rs->getString($startcol + 8);

			$this->member_address1 = $rs->getString($startcol + 9);

			$this->member_address2 = $rs->getString($startcol + 10);

			$this->member_zip = $rs->getString($startcol + 11);

			$this->member_city = $rs->getString($startcol + 12);

			$this->katao_name = $rs->getString($startcol + 13);

			$this->katao_address = $rs->getString($startcol + 14);

			$this->katao_siret_number = $rs->getString($startcol + 15);

			$this->katao_rcs_number = $rs->getString($startcol + 16);

			$this->katao_capital = $rs->getInt($startcol + 17);

			$this->sol_amount = $rs->getInt($startcol + 18);

			$this->created_at = $rs->getTimestamp($startcol + 19, null);

			$this->updated_at = $rs->getTimestamp($startcol + 20, null);

			$this->resetModified();

			$this->setNew(false);

			// FIXME - using NUM_COLUMNS may be clearer.
			return $startcol + 21; // 21 = KataoInvoicePeer::NUM_COLUMNS - KataoInvoicePeer::NUM_LAZY_LOAD_COLUMNS).

		} catch (Exception $e) {
			throw new PropelException("Error populating KataoInvoice object", $e);
		}
	}

	/**
	 * Removes this object from datastore and sets delete attribute.
	 *
	 * @param      Connection $con
	 * @return     void
	 * @throws     PropelException
	 * @see        BaseObject::setDeleted()
	 * @see        BaseObject::isDeleted()
	 */
	public function delete($con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoInvoice:delete:pre') as $callable)
    {
      $ret = call_user_func($callable, $this, $con);
      if ($ret)
      {
        return;
      }
    }


		if ($this->isDeleted()) {
			throw new PropelException("This object has already been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(KataoInvoicePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			KataoInvoicePeer::doDelete($this, $con);
			$this->setDeleted(true);
			$con->commit();
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	

    foreach (sfMixer::getCallables('BaseKataoInvoice:delete:post') as $callable)
    {
      call_user_func($callable, $this, $con);
    }

  }
	/**
	 * Stores the object in the database.  If the object is new,
	 * it inserts it; otherwise an update is performed.  This method
	 * wraps the doSave() worker method in a transaction.
	 *
	 * @param      Connection $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        doSave()
	 */
	public function save($con = null)
	{

    foreach (sfMixer::getCallables('BaseKataoInvoice:save:pre') as $callable)
    {
      $affectedRows = call_user_func($callable, $this, $con);
      if (is_int($affectedRows))
      {
        return $affectedRows;
      }
    }


    if ($this->isNew() && !$this->isColumnModified(KataoInvoicePeer::CREATED_AT))
    {
      $this->setCreatedAt(time());
    }

    if ($this->isModified() && !$this->isColumnModified(KataoInvoicePeer::UPDATED_AT))
    {
      $this->setUpdatedAt(time());
    }

		if ($this->isDeleted()) {
			throw new PropelException("You cannot save an object that has been deleted.");
		}

		if ($con === null) {
			$con = Propel::getConnection(KataoInvoicePeer::DATABASE_NAME);
		}

		try {
			$con->begin();
			$affectedRows = $this->doSave($con);
			$con->commit();
    foreach (sfMixer::getCallables('BaseKataoInvoice:save:post') as $callable)
    {
      call_user_func($callable, $this, $con, $affectedRows);
    }

			return $affectedRows;
		} catch (PropelException $e) {
			$con->rollback();
			throw $e;
		}
	}

	/**
	 * Stores the object in the database.
	 *
	 * If the object is new, it inserts it; otherwise an update is performed.
	 * All related objects are also updated in this method.
	 *
	 * @param      Connection $con
	 * @return     int The number of rows affected by this insert/update and any referring fk objects' save() operations.
	 * @throws     PropelException
	 * @see        save()
	 */
	protected function doSave($con)
	{
		$affectedRows = 0; // initialize var to track total num of affected rows
		if (!$this->alreadyInSave) {
			$this->alreadyInSave = true;


			// We call the save method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aKataoMember !== null) {
				if ($this->aKataoMember->isModified()) {
					$affectedRows += $this->aKataoMember->save($con);
				}
				$this->setKataoMember($this->aKataoMember);
			}

			if ($this->aKataoPeriod !== null) {
				if ($this->aKataoPeriod->isModified()) {
					$affectedRows += $this->aKataoPeriod->save($con);
				}
				$this->setKataoPeriod($this->aKataoPeriod);
			}

			if ($this->aKataoNode !== null) {
				if ($this->aKataoNode->isModified()) {
					$affectedRows += $this->aKataoNode->save($con);
				}
				$this->setKataoNode($this->aKataoNode);
			}

			if ($this->aKataoCart !== null) {
				if ($this->aKataoCart->isModified()) {
					$affectedRows += $this->aKataoCart->save($con);
				}
				$this->setKataoCart($this->aKataoCart);
			}


			// If this object has been modified, then save it to the database.
			if ($this->isModified()) {
				if ($this->isNew()) {
					$pk = KataoInvoicePeer::doInsert($this, $con);
					$affectedRows += 1; // we are assuming that there is only 1 row per doInsert() which
										 // should always be true here (even though technically
										 // BasePeer::doInsert() can insert multiple rows).

					$this->setId($pk);  //[IMV] update autoincrement primary key

					$this->setNew(false);
				} else {
					$affectedRows += KataoInvoicePeer::doUpdate($this, $con);
				}
				$this->resetModified(); // [HL] After being saved an object is no longer 'modified'
			}

			if ($this->collKataoInvoiceProducts !== null) {
				foreach($this->collKataoInvoiceProducts as $referrerFK) {
					if (!$referrerFK->isDeleted()) {
						$affectedRows += $referrerFK->save($con);
					}
				}
			}

			$this->alreadyInSave = false;
		}
		return $affectedRows;
	} // doSave()

	/**
	 * Array of ValidationFailed objects.
	 * @var        array ValidationFailed[]
	 */
	protected $validationFailures = array();

	/**
	 * Gets any ValidationFailed objects that resulted from last call to validate().
	 *
	 *
	 * @return     array ValidationFailed[]
	 * @see        validate()
	 */
	public function getValidationFailures()
	{
		return $this->validationFailures;
	}

	/**
	 * Validates the objects modified field values and all objects related to this table.
	 *
	 * If $columns is either a column name or an array of column names
	 * only those columns are validated.
	 *
	 * @param      mixed $columns Column name or an array of column names.
	 * @return     boolean Whether all columns pass validation.
	 * @see        doValidate()
	 * @see        getValidationFailures()
	 */
	public function validate($columns = null)
	{
		$res = $this->doValidate($columns);
		if ($res === true) {
			$this->validationFailures = array();
			return true;
		} else {
			$this->validationFailures = $res;
			return false;
		}
	}

	/**
	 * This function performs the validation work for complex object models.
	 *
	 * In addition to checking the current object, all related objects will
	 * also be validated.  If all pass then <code>true</code> is returned; otherwise
	 * an aggreagated array of ValidationFailed objects will be returned.
	 *
	 * @param      array $columns Array of column names to validate.
	 * @return     mixed <code>true</code> if all validations pass; array of <code>ValidationFailed</code> objets otherwise.
	 */
	protected function doValidate($columns = null)
	{
		if (!$this->alreadyInValidation) {
			$this->alreadyInValidation = true;
			$retval = null;

			$failureMap = array();


			// We call the validate method on the following object(s) if they
			// were passed to this object by their coresponding set
			// method.  This object relates to these object(s) by a
			// foreign key reference.

			if ($this->aKataoMember !== null) {
				if (!$this->aKataoMember->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aKataoMember->getValidationFailures());
				}
			}

			if ($this->aKataoPeriod !== null) {
				if (!$this->aKataoPeriod->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aKataoPeriod->getValidationFailures());
				}
			}

			if ($this->aKataoNode !== null) {
				if (!$this->aKataoNode->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aKataoNode->getValidationFailures());
				}
			}

			if ($this->aKataoCart !== null) {
				if (!$this->aKataoCart->validate($columns)) {
					$failureMap = array_merge($failureMap, $this->aKataoCart->getValidationFailures());
				}
			}


			if (($retval = KataoInvoicePeer::doValidate($this, $columns)) !== true) {
				$failureMap = array_merge($failureMap, $retval);
			}


				if ($this->collKataoInvoiceProducts !== null) {
					foreach($this->collKataoInvoiceProducts as $referrerFK) {
						if (!$referrerFK->validate($columns)) {
							$failureMap = array_merge($failureMap, $referrerFK->getValidationFailures());
						}
					}
				}


			$this->alreadyInValidation = false;
		}

		return (!empty($failureMap) ? $failureMap : true);
	}

	/**
	 * Retrieves a field from the object by name passed in as a string.
	 *
	 * @param      string $name name
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return     mixed Value of field.
	 */
	public function getByName($name, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = KataoInvoicePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->getByPosition($pos);
	}

	/**
	 * Retrieves a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @return     mixed Value of field at $pos
	 */
	public function getByPosition($pos)
	{
		switch($pos) {
			case 0:
				return $this->getId();
				break;
			case 1:
				return $this->getKataoMemberId();
				break;
			case 2:
				return $this->getKataoPeriodId();
				break;
			case 3:
				return $this->getKataoNodeId();
				break;
			case 4:
				return $this->getKataoCartId();
				break;
			case 5:
				return $this->getStatus();
				break;
			case 6:
				return $this->getMemberFirstName();
				break;
			case 7:
				return $this->getMemberLastName();
				break;
			case 8:
				return $this->getMemberEmail();
				break;
			case 9:
				return $this->getMemberAddress1();
				break;
			case 10:
				return $this->getMemberAddress2();
				break;
			case 11:
				return $this->getMemberZip();
				break;
			case 12:
				return $this->getMemberCity();
				break;
			case 13:
				return $this->getKataoName();
				break;
			case 14:
				return $this->getKataoAddress();
				break;
			case 15:
				return $this->getKataoSiretNumber();
				break;
			case 16:
				return $this->getKataoRcsNumber();
				break;
			case 17:
				return $this->getKataoCapital();
				break;
			case 18:
				return $this->getSolAmount();
				break;
			case 19:
				return $this->getCreatedAt();
				break;
			case 20:
				return $this->getUpdatedAt();
				break;
			default:
				return null;
				break;
		} // switch()
	}

	/**
	 * Exports the object as an array.
	 *
	 * You can specify the key type of the array by passing one of the class
	 * type constants.
	 *
	 * @param      string $keyType One of the class type constants TYPE_PHPNAME,
	 *                        TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return     an associative array containing the field names (as keys) and field values
	 */
	public function toArray($keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = KataoInvoicePeer::getFieldNames($keyType);
		$result = array(
			$keys[0] => $this->getId(),
			$keys[1] => $this->getKataoMemberId(),
			$keys[2] => $this->getKataoPeriodId(),
			$keys[3] => $this->getKataoNodeId(),
			$keys[4] => $this->getKataoCartId(),
			$keys[5] => $this->getStatus(),
			$keys[6] => $this->getMemberFirstName(),
			$keys[7] => $this->getMemberLastName(),
			$keys[8] => $this->getMemberEmail(),
			$keys[9] => $this->getMemberAddress1(),
			$keys[10] => $this->getMemberAddress2(),
			$keys[11] => $this->getMemberZip(),
			$keys[12] => $this->getMemberCity(),
			$keys[13] => $this->getKataoName(),
			$keys[14] => $this->getKataoAddress(),
			$keys[15] => $this->getKataoSiretNumber(),
			$keys[16] => $this->getKataoRcsNumber(),
			$keys[17] => $this->getKataoCapital(),
			$keys[18] => $this->getSolAmount(),
			$keys[19] => $this->getCreatedAt(),
			$keys[20] => $this->getUpdatedAt(),
		);
		return $result;
	}

	/**
	 * Sets a field from the object by name passed in as a string.
	 *
	 * @param      string $name peer name
	 * @param      mixed $value field value
	 * @param      string $type The type of fieldname the $name is of:
	 *                     one of the class type constants TYPE_PHPNAME,
	 *                     TYPE_COLNAME, TYPE_FIELDNAME, TYPE_NUM
	 * @return     void
	 */
	public function setByName($name, $value, $type = BasePeer::TYPE_PHPNAME)
	{
		$pos = KataoInvoicePeer::translateFieldName($name, $type, BasePeer::TYPE_NUM);
		return $this->setByPosition($pos, $value);
	}

	/**
	 * Sets a field from the object by Position as specified in the xml schema.
	 * Zero-based.
	 *
	 * @param      int $pos position in xml schema
	 * @param      mixed $value field value
	 * @return     void
	 */
	public function setByPosition($pos, $value)
	{
		switch($pos) {
			case 0:
				$this->setId($value);
				break;
			case 1:
				$this->setKataoMemberId($value);
				break;
			case 2:
				$this->setKataoPeriodId($value);
				break;
			case 3:
				$this->setKataoNodeId($value);
				break;
			case 4:
				$this->setKataoCartId($value);
				break;
			case 5:
				$this->setStatus($value);
				break;
			case 6:
				$this->setMemberFirstName($value);
				break;
			case 7:
				$this->setMemberLastName($value);
				break;
			case 8:
				$this->setMemberEmail($value);
				break;
			case 9:
				$this->setMemberAddress1($value);
				break;
			case 10:
				$this->setMemberAddress2($value);
				break;
			case 11:
				$this->setMemberZip($value);
				break;
			case 12:
				$this->setMemberCity($value);
				break;
			case 13:
				$this->setKataoName($value);
				break;
			case 14:
				$this->setKataoAddress($value);
				break;
			case 15:
				$this->setKataoSiretNumber($value);
				break;
			case 16:
				$this->setKataoRcsNumber($value);
				break;
			case 17:
				$this->setKataoCapital($value);
				break;
			case 18:
				$this->setSolAmount($value);
				break;
			case 19:
				$this->setCreatedAt($value);
				break;
			case 20:
				$this->setUpdatedAt($value);
				break;
		} // switch()
	}

	/**
	 * Populates the object using an array.
	 *
	 * This is particularly useful when populating an object from one of the
	 * request arrays (e.g. $_POST).  This method goes through the column
	 * names, checking to see whether a matching key exists in populated
	 * array. If so the setByName() method is called for that column.
	 *
	 * You can specify the key type of the array by additionally passing one
	 * of the class type constants TYPE_PHPNAME, TYPE_COLNAME, TYPE_FIELDNAME,
	 * TYPE_NUM. The default key type is the column's phpname (e.g. 'authorId')
	 *
	 * @param      array  $arr     An array to populate the object from.
	 * @param      string $keyType The type of keys the array uses.
	 * @return     void
	 */
	public function fromArray($arr, $keyType = BasePeer::TYPE_PHPNAME)
	{
		$keys = KataoInvoicePeer::getFieldNames($keyType);

		if (array_key_exists($keys[0], $arr)) $this->setId($arr[$keys[0]]);
		if (array_key_exists($keys[1], $arr)) $this->setKataoMemberId($arr[$keys[1]]);
		if (array_key_exists($keys[2], $arr)) $this->setKataoPeriodId($arr[$keys[2]]);
		if (array_key_exists($keys[3], $arr)) $this->setKataoNodeId($arr[$keys[3]]);
		if (array_key_exists($keys[4], $arr)) $this->setKataoCartId($arr[$keys[4]]);
		if (array_key_exists($keys[5], $arr)) $this->setStatus($arr[$keys[5]]);
		if (array_key_exists($keys[6], $arr)) $this->setMemberFirstName($arr[$keys[6]]);
		if (array_key_exists($keys[7], $arr)) $this->setMemberLastName($arr[$keys[7]]);
		if (array_key_exists($keys[8], $arr)) $this->setMemberEmail($arr[$keys[8]]);
		if (array_key_exists($keys[9], $arr)) $this->setMemberAddress1($arr[$keys[9]]);
		if (array_key_exists($keys[10], $arr)) $this->setMemberAddress2($arr[$keys[10]]);
		if (array_key_exists($keys[11], $arr)) $this->setMemberZip($arr[$keys[11]]);
		if (array_key_exists($keys[12], $arr)) $this->setMemberCity($arr[$keys[12]]);
		if (array_key_exists($keys[13], $arr)) $this->setKataoName($arr[$keys[13]]);
		if (array_key_exists($keys[14], $arr)) $this->setKataoAddress($arr[$keys[14]]);
		if (array_key_exists($keys[15], $arr)) $this->setKataoSiretNumber($arr[$keys[15]]);
		if (array_key_exists($keys[16], $arr)) $this->setKataoRcsNumber($arr[$keys[16]]);
		if (array_key_exists($keys[17], $arr)) $this->setKataoCapital($arr[$keys[17]]);
		if (array_key_exists($keys[18], $arr)) $this->setSolAmount($arr[$keys[18]]);
		if (array_key_exists($keys[19], $arr)) $this->setCreatedAt($arr[$keys[19]]);
		if (array_key_exists($keys[20], $arr)) $this->setUpdatedAt($arr[$keys[20]]);
	}

	/**
	 * Build a Criteria object containing the values of all modified columns in this object.
	 *
	 * @return     Criteria The Criteria object containing all modified values.
	 */
	public function buildCriteria()
	{
		$criteria = new Criteria(KataoInvoicePeer::DATABASE_NAME);

		if ($this->isColumnModified(KataoInvoicePeer::ID)) $criteria->add(KataoInvoicePeer::ID, $this->id);
		if ($this->isColumnModified(KataoInvoicePeer::KATAO_MEMBER_ID)) $criteria->add(KataoInvoicePeer::KATAO_MEMBER_ID, $this->katao_member_id);
		if ($this->isColumnModified(KataoInvoicePeer::KATAO_PERIOD_ID)) $criteria->add(KataoInvoicePeer::KATAO_PERIOD_ID, $this->katao_period_id);
		if ($this->isColumnModified(KataoInvoicePeer::KATAO_NODE_ID)) $criteria->add(KataoInvoicePeer::KATAO_NODE_ID, $this->katao_node_id);
		if ($this->isColumnModified(KataoInvoicePeer::KATAO_CART_ID)) $criteria->add(KataoInvoicePeer::KATAO_CART_ID, $this->katao_cart_id);
		if ($this->isColumnModified(KataoInvoicePeer::STATUS)) $criteria->add(KataoInvoicePeer::STATUS, $this->status);
		if ($this->isColumnModified(KataoInvoicePeer::MEMBER_FIRST_NAME)) $criteria->add(KataoInvoicePeer::MEMBER_FIRST_NAME, $this->member_first_name);
		if ($this->isColumnModified(KataoInvoicePeer::MEMBER_LAST_NAME)) $criteria->add(KataoInvoicePeer::MEMBER_LAST_NAME, $this->member_last_name);
		if ($this->isColumnModified(KataoInvoicePeer::MEMBER_EMAIL)) $criteria->add(KataoInvoicePeer::MEMBER_EMAIL, $this->member_email);
		if ($this->isColumnModified(KataoInvoicePeer::MEMBER_ADDRESS1)) $criteria->add(KataoInvoicePeer::MEMBER_ADDRESS1, $this->member_address1);
		if ($this->isColumnModified(KataoInvoicePeer::MEMBER_ADDRESS2)) $criteria->add(KataoInvoicePeer::MEMBER_ADDRESS2, $this->member_address2);
		if ($this->isColumnModified(KataoInvoicePeer::MEMBER_ZIP)) $criteria->add(KataoInvoicePeer::MEMBER_ZIP, $this->member_zip);
		if ($this->isColumnModified(KataoInvoicePeer::MEMBER_CITY)) $criteria->add(KataoInvoicePeer::MEMBER_CITY, $this->member_city);
		if ($this->isColumnModified(KataoInvoicePeer::KATAO_NAME)) $criteria->add(KataoInvoicePeer::KATAO_NAME, $this->katao_name);
		if ($this->isColumnModified(KataoInvoicePeer::KATAO_ADDRESS)) $criteria->add(KataoInvoicePeer::KATAO_ADDRESS, $this->katao_address);
		if ($this->isColumnModified(KataoInvoicePeer::KATAO_SIRET_NUMBER)) $criteria->add(KataoInvoicePeer::KATAO_SIRET_NUMBER, $this->katao_siret_number);
		if ($this->isColumnModified(KataoInvoicePeer::KATAO_RCS_NUMBER)) $criteria->add(KataoInvoicePeer::KATAO_RCS_NUMBER, $this->katao_rcs_number);
		if ($this->isColumnModified(KataoInvoicePeer::KATAO_CAPITAL)) $criteria->add(KataoInvoicePeer::KATAO_CAPITAL, $this->katao_capital);
		if ($this->isColumnModified(KataoInvoicePeer::SOL_AMOUNT)) $criteria->add(KataoInvoicePeer::SOL_AMOUNT, $this->sol_amount);
		if ($this->isColumnModified(KataoInvoicePeer::CREATED_AT)) $criteria->add(KataoInvoicePeer::CREATED_AT, $this->created_at);
		if ($this->isColumnModified(KataoInvoicePeer::UPDATED_AT)) $criteria->add(KataoInvoicePeer::UPDATED_AT, $this->updated_at);

		return $criteria;
	}

	/**
	 * Builds a Criteria object containing the primary key for this object.
	 *
	 * Unlike buildCriteria() this method includes the primary key values regardless
	 * of whether or not they have been modified.
	 *
	 * @return     Criteria The Criteria object containing value(s) for primary key(s).
	 */
	public function buildPkeyCriteria()
	{
		$criteria = new Criteria(KataoInvoicePeer::DATABASE_NAME);

		$criteria->add(KataoInvoicePeer::ID, $this->id);

		return $criteria;
	}

	/**
	 * Returns the primary key for this object (row).
	 * @return     int
	 */
	public function getPrimaryKey()
	{
		return $this->getId();
	}

	/**
	 * Generic method to set the primary key (id column).
	 *
	 * @param      int $key Primary key.
	 * @return     void
	 */
	public function setPrimaryKey($key)
	{
		$this->setId($key);
	}

	/**
	 * Sets contents of passed object to values from current object.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      object $copyObj An object of KataoInvoice (or compatible) type.
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @throws     PropelException
	 */
	public function copyInto($copyObj, $deepCopy = false)
	{

		$copyObj->setKataoMemberId($this->katao_member_id);

		$copyObj->setKataoPeriodId($this->katao_period_id);

		$copyObj->setKataoNodeId($this->katao_node_id);

		$copyObj->setKataoCartId($this->katao_cart_id);

		$copyObj->setStatus($this->status);

		$copyObj->setMemberFirstName($this->member_first_name);

		$copyObj->setMemberLastName($this->member_last_name);

		$copyObj->setMemberEmail($this->member_email);

		$copyObj->setMemberAddress1($this->member_address1);

		$copyObj->setMemberAddress2($this->member_address2);

		$copyObj->setMemberZip($this->member_zip);

		$copyObj->setMemberCity($this->member_city);

		$copyObj->setKataoName($this->katao_name);

		$copyObj->setKataoAddress($this->katao_address);

		$copyObj->setKataoSiretNumber($this->katao_siret_number);

		$copyObj->setKataoRcsNumber($this->katao_rcs_number);

		$copyObj->setKataoCapital($this->katao_capital);

		$copyObj->setSolAmount($this->sol_amount);

		$copyObj->setCreatedAt($this->created_at);

		$copyObj->setUpdatedAt($this->updated_at);


		if ($deepCopy) {
			// important: temporarily setNew(false) because this affects the behavior of
			// the getter/setter methods for fkey referrer objects.
			$copyObj->setNew(false);

			foreach($this->getKataoInvoiceProducts() as $relObj) {
				$copyObj->addKataoInvoiceProduct($relObj->copy($deepCopy));
			}

		} // if ($deepCopy)


		$copyObj->setNew(true);

		$copyObj->setId(NULL); // this is a pkey column, so set to default value

	}

	/**
	 * Makes a copy of this object that will be inserted as a new row in table when saved.
	 * It creates a new object filling in the simple attributes, but skipping any primary
	 * keys that are defined for the table.
	 *
	 * If desired, this method can also make copies of all associated (fkey referrers)
	 * objects.
	 *
	 * @param      boolean $deepCopy Whether to also copy all rows that refer (by fkey) to the current row.
	 * @return     KataoInvoice Clone of current object.
	 * @throws     PropelException
	 */
	public function copy($deepCopy = false)
	{
		// we use get_class(), because this might be a subclass
		$clazz = get_class($this);
		$copyObj = new $clazz();
		$this->copyInto($copyObj, $deepCopy);
		return $copyObj;
	}

	/**
	 * Returns a peer instance associated with this om.
	 *
	 * Since Peer classes are not to have any instance attributes, this method returns the
	 * same instance for all member of this class. The method could therefore
	 * be static, but this would prevent one from overriding the behavior.
	 *
	 * @return     KataoInvoicePeer
	 */
	public function getPeer()
	{
		if (self::$peer === null) {
			self::$peer = new KataoInvoicePeer();
		}
		return self::$peer;
	}

	/**
	 * Declares an association between this object and a KataoMember object.
	 *
	 * @param      KataoMember $v
	 * @return     void
	 * @throws     PropelException
	 */
	public function setKataoMember($v)
	{


		if ($v === null) {
			$this->setKataoMemberId(NULL);
		} else {
			$this->setKataoMemberId($v->getId());
		}


		$this->aKataoMember = $v;
	}


	/**
	 * Get the associated KataoMember object
	 *
	 * @param      Connection Optional Connection object.
	 * @return     KataoMember The associated KataoMember object.
	 * @throws     PropelException
	 */
	public function getKataoMember($con = null)
	{
		if ($this->aKataoMember === null && ($this->katao_member_id !== null)) {
			// include the related Peer class
			$this->aKataoMember = KataoMemberPeer::retrieveByPK($this->katao_member_id, $con);

			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = KataoMemberPeer::retrieveByPK($this->katao_member_id, $con);
			   $obj->addKataoMembers($this);
			 */
		}
		return $this->aKataoMember;
	}

	/**
	 * Declares an association between this object and a KataoPeriod object.
	 *
	 * @param      KataoPeriod $v
	 * @return     void
	 * @throws     PropelException
	 */
	public function setKataoPeriod($v)
	{


		if ($v === null) {
			$this->setKataoPeriodId(NULL);
		} else {
			$this->setKataoPeriodId($v->getId());
		}


		$this->aKataoPeriod = $v;
	}


	/**
	 * Get the associated KataoPeriod object
	 *
	 * @param      Connection Optional Connection object.
	 * @return     KataoPeriod The associated KataoPeriod object.
	 * @throws     PropelException
	 */
	public function getKataoPeriod($con = null)
	{
		if ($this->aKataoPeriod === null && ($this->katao_period_id !== null)) {
			// include the related Peer class
			$this->aKataoPeriod = KataoPeriodPeer::retrieveByPK($this->katao_period_id, $con);

			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = KataoPeriodPeer::retrieveByPK($this->katao_period_id, $con);
			   $obj->addKataoPeriods($this);
			 */
		}
		return $this->aKataoPeriod;
	}

	/**
	 * Declares an association between this object and a KataoNode object.
	 *
	 * @param      KataoNode $v
	 * @return     void
	 * @throws     PropelException
	 */
	public function setKataoNode($v)
	{


		if ($v === null) {
			$this->setKataoNodeId(NULL);
		} else {
			$this->setKataoNodeId($v->getId());
		}


		$this->aKataoNode = $v;
	}


	/**
	 * Get the associated KataoNode object
	 *
	 * @param      Connection Optional Connection object.
	 * @return     KataoNode The associated KataoNode object.
	 * @throws     PropelException
	 */
	public function getKataoNode($con = null)
	{
		if ($this->aKataoNode === null && ($this->katao_node_id !== null)) {
			// include the related Peer class
			$this->aKataoNode = KataoNodePeer::retrieveByPK($this->katao_node_id, $con);

			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = KataoNodePeer::retrieveByPK($this->katao_node_id, $con);
			   $obj->addKataoNodes($this);
			 */
		}
		return $this->aKataoNode;
	}

	/**
	 * Declares an association between this object and a KataoCart object.
	 *
	 * @param      KataoCart $v
	 * @return     void
	 * @throws     PropelException
	 */
	public function setKataoCart($v)
	{


		if ($v === null) {
			$this->setKataoCartId(NULL);
		} else {
			$this->setKataoCartId($v->getId());
		}


		$this->aKataoCart = $v;
	}


	/**
	 * Get the associated KataoCart object
	 *
	 * @param      Connection Optional Connection object.
	 * @return     KataoCart The associated KataoCart object.
	 * @throws     PropelException
	 */
	public function getKataoCart($con = null)
	{
		if ($this->aKataoCart === null && ($this->katao_cart_id !== null)) {
			// include the related Peer class
			$this->aKataoCart = KataoCartPeer::retrieveByPK($this->katao_cart_id, $con);

			/* The following can be used instead of the line above to
			   guarantee the related object contains a reference
			   to this object, but this level of coupling
			   may be undesirable in many circumstances.
			   As it can lead to a db query with many results that may
			   never be used.
			   $obj = KataoCartPeer::retrieveByPK($this->katao_cart_id, $con);
			   $obj->addKataoCarts($this);
			 */
		}
		return $this->aKataoCart;
	}

	/**
	 * Temporary storage of collKataoInvoiceProducts to save a possible db hit in
	 * the event objects are add to the collection, but the
	 * complete collection is never requested.
	 * @return     void
	 */
	public function initKataoInvoiceProducts()
	{
		if ($this->collKataoInvoiceProducts === null) {
			$this->collKataoInvoiceProducts = array();
		}
	}

	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this KataoInvoice has previously
	 * been saved, it will retrieve related KataoInvoiceProducts from storage.
	 * If this KataoInvoice is new, it will return
	 * an empty collection or the current collection, the criteria
	 * is ignored on a new object.
	 *
	 * @param      Connection $con
	 * @param      Criteria $criteria
	 * @throws     PropelException
	 */
	public function getKataoInvoiceProducts($criteria = null, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collKataoInvoiceProducts === null) {
			if ($this->isNew()) {
			   $this->collKataoInvoiceProducts = array();
			} else {

				$criteria->add(KataoInvoiceProductPeer::KATAO_INVOICE_ID, $this->getId());

				KataoInvoiceProductPeer::addSelectColumns($criteria);
				$this->collKataoInvoiceProducts = KataoInvoiceProductPeer::doSelect($criteria, $con);
			}
		} else {
			// criteria has no effect for a new object
			if (!$this->isNew()) {
				// the following code is to determine if a new query is
				// called for.  If the criteria is the same as the last
				// one, just return the collection.


				$criteria->add(KataoInvoiceProductPeer::KATAO_INVOICE_ID, $this->getId());

				KataoInvoiceProductPeer::addSelectColumns($criteria);
				if (!isset($this->lastKataoInvoiceProductCriteria) || !$this->lastKataoInvoiceProductCriteria->equals($criteria)) {
					$this->collKataoInvoiceProducts = KataoInvoiceProductPeer::doSelect($criteria, $con);
				}
			}
		}
		$this->lastKataoInvoiceProductCriteria = $criteria;
		return $this->collKataoInvoiceProducts;
	}

	/**
	 * Returns the number of related KataoInvoiceProducts.
	 *
	 * @param      Criteria $criteria
	 * @param      boolean $distinct
	 * @param      Connection $con
	 * @throws     PropelException
	 */
	public function countKataoInvoiceProducts($criteria = null, $distinct = false, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		$criteria->add(KataoInvoiceProductPeer::KATAO_INVOICE_ID, $this->getId());

		return KataoInvoiceProductPeer::doCount($criteria, $distinct, $con);
	}

	/**
	 * Method called to associate a KataoInvoiceProduct object to this object
	 * through the KataoInvoiceProduct foreign key attribute
	 *
	 * @param      KataoInvoiceProduct $l KataoInvoiceProduct
	 * @return     void
	 * @throws     PropelException
	 */
	public function addKataoInvoiceProduct(KataoInvoiceProduct $l)
	{
		$this->collKataoInvoiceProducts[] = $l;
		$l->setKataoInvoice($this);
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this KataoInvoice is new, it will return
	 * an empty collection; or if this KataoInvoice has previously
	 * been saved, it will retrieve related KataoInvoiceProducts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in KataoInvoice.
	 */
	public function getKataoInvoiceProductsJoinKataoProduct($criteria = null, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collKataoInvoiceProducts === null) {
			if ($this->isNew()) {
				$this->collKataoInvoiceProducts = array();
			} else {

				$criteria->add(KataoInvoiceProductPeer::KATAO_INVOICE_ID, $this->getId());

				$this->collKataoInvoiceProducts = KataoInvoiceProductPeer::doSelectJoinKataoProduct($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(KataoInvoiceProductPeer::KATAO_INVOICE_ID, $this->getId());

			if (!isset($this->lastKataoInvoiceProductCriteria) || !$this->lastKataoInvoiceProductCriteria->equals($criteria)) {
				$this->collKataoInvoiceProducts = KataoInvoiceProductPeer::doSelectJoinKataoProduct($criteria, $con);
			}
		}
		$this->lastKataoInvoiceProductCriteria = $criteria;

		return $this->collKataoInvoiceProducts;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this KataoInvoice is new, it will return
	 * an empty collection; or if this KataoInvoice has previously
	 * been saved, it will retrieve related KataoInvoiceProducts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in KataoInvoice.
	 */
	public function getKataoInvoiceProductsJoinKataoCartProduct($criteria = null, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collKataoInvoiceProducts === null) {
			if ($this->isNew()) {
				$this->collKataoInvoiceProducts = array();
			} else {

				$criteria->add(KataoInvoiceProductPeer::KATAO_INVOICE_ID, $this->getId());

				$this->collKataoInvoiceProducts = KataoInvoiceProductPeer::doSelectJoinKataoCartProduct($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(KataoInvoiceProductPeer::KATAO_INVOICE_ID, $this->getId());

			if (!isset($this->lastKataoInvoiceProductCriteria) || !$this->lastKataoInvoiceProductCriteria->equals($criteria)) {
				$this->collKataoInvoiceProducts = KataoInvoiceProductPeer::doSelectJoinKataoCartProduct($criteria, $con);
			}
		}
		$this->lastKataoInvoiceProductCriteria = $criteria;

		return $this->collKataoInvoiceProducts;
	}


	/**
	 * If this collection has already been initialized with
	 * an identical criteria, it returns the collection.
	 * Otherwise if this KataoInvoice is new, it will return
	 * an empty collection; or if this KataoInvoice has previously
	 * been saved, it will retrieve related KataoInvoiceProducts from storage.
	 *
	 * This method is protected by default in order to keep the public
	 * api reasonable.  You can provide public methods for those you
	 * actually need in KataoInvoice.
	 */
	public function getKataoInvoiceProductsJoinKataoOrderProduct($criteria = null, $con = null)
	{
		// include the Peer class
		if ($criteria === null) {
			$criteria = new Criteria();
		}
		elseif ($criteria instanceof Criteria)
		{
			$criteria = clone $criteria;
		}

		if ($this->collKataoInvoiceProducts === null) {
			if ($this->isNew()) {
				$this->collKataoInvoiceProducts = array();
			} else {

				$criteria->add(KataoInvoiceProductPeer::KATAO_INVOICE_ID, $this->getId());

				$this->collKataoInvoiceProducts = KataoInvoiceProductPeer::doSelectJoinKataoOrderProduct($criteria, $con);
			}
		} else {
			// the following code is to determine if a new query is
			// called for.  If the criteria is the same as the last
			// one, just return the collection.

			$criteria->add(KataoInvoiceProductPeer::KATAO_INVOICE_ID, $this->getId());

			if (!isset($this->lastKataoInvoiceProductCriteria) || !$this->lastKataoInvoiceProductCriteria->equals($criteria)) {
				$this->collKataoInvoiceProducts = KataoInvoiceProductPeer::doSelectJoinKataoOrderProduct($criteria, $con);
			}
		}
		$this->lastKataoInvoiceProductCriteria = $criteria;

		return $this->collKataoInvoiceProducts;
	}


  public function __call($method, $arguments)
  {
    if (!$callable = sfMixer::getCallable('BaseKataoInvoice:'.$method))
    {
      throw new sfException(sprintf('Call to undefined method BaseKataoInvoice::%s', $method));
    }

    array_unshift($arguments, $this);

    return call_user_func_array($callable, $arguments);
  }


} // BaseKataoInvoice
